import { world, ItemStack } from '@minecraft/server'

world.afterEvents.entityDie.subscribe(e => {
    const { deadEntity, damageSource } = e;

    if (!damageSource.damagingEntity || damageSource.damagingEntity.typeId !== 'minecraft:player') return;
    const player = damageSource.damagingEntity;

    const entityDrops = {
        'minecraft:wither': [
            { item: 'arena:wither_fire', amount: 1, prob: 100, condition: 1 }
        ],
        'minecraft:ender_dragon': [
            { item: 'arena:dragon_scale', amount: 9, prob: 100, condition: 1 }
        ],
        'minecraft:warden': [
            { item: 'arena:warden_heart', amount: 1, prob: 100, condition: 1 }
        ],
        'minecraft:piglin_brute': [
            { item: 'arena:piglin_bracelet_charm', amount: 1, prob: 5, condition: 1 }
        ],
        'minecraft:enderman': [
            { item: 'arena:obsidian_eye_talisman', amount: 1, prob: 5, condition: 1 }
        ],
        'minecraft:villager': [
            { item: 'arena:chained_heart_talisman', amount: 1, prob: 5, condition: 1 }
        ]
    };

    const drops = entityDrops[deadEntity.typeId];
    if (!drops) return;

    drops.forEach(drop => {
        if (!drop.condition) return;

        const randomChance = Math.random() * 100;
        if (randomChance > drop.prob) return;

        try {
            deadEntity.dimension.spawnItem(new ItemStack(drop.item, drop.amount), deadEntity.location);
        } catch {
            player.dimension.spawnItem(new ItemStack(drop.item, drop.amount), player.location);
        }
    });
});