import { world, system, ItemStack } from '@minecraft/server'

system.runInterval(() => {
    let players = world.getAllPlayers();
    players.forEach(player => {
    if (player.hasTag('arena:ethereal_sight_mask_head')) {
    player.runCommand("execute as @s at @s in the_end if entity @s [r=1] if entity @s[x=~,y=-17,z=~,r=23] run function fall");
     }

    if (!player.hasTag('scroll')) {
    player.runCommand("give @s twm:scroll");
    player.addTag('scroll');
     }
 })
}, 120);

world.afterEvents.itemUse.subscribe( async(data) => {
  let player = data.source;
  let equip = player.getComponent('equippable');
  let item = data.itemStack; {

 if (item.typeId == "arena:scroll"){   
    player.runCommand('function empty');
    }

    }
});

world.afterEvents.worldInitialize.subscribe(() => {
    system.runInterval(() => {
        // We obtain all the players 
        let players = world.getAllPlayers()
        players.forEach(player => {

            if (player.hasTag('arena:archaic_marble_wings_archaiccharm')) {
        let jumps = player.getDynamicProperty('arena:jumps') || 0
        const maxExtraJumps = 2
        if (player.isFalling && jumps < maxExtraJumps) {
          if (player.isJumping) {
            let { x, y, z } = player.getVelocity()
            player.applyKnockback(x, z, Math.SQRT2 * Math.sqrt(x * x + z * z), 1.25)
            jumps += 1
          }
        }
        if (player.isOnGround) {
          jumps = 0
        }
        player.setDynamicProperty('arena:jumps', jumps)
      }
      if (player.hasTag('arena:archaic_marble_wings_archaiccharm')  && player.hasTag('arena:hermes_boots_talisman_talisman') && player.getComponent('equippable').getEquipment('Chest')?.typeId == 'arena:marble_chestplate') {
        let jumps = player.getDynamicProperty('arena:jumps') || 0
        const maxExtraJumps = 4
        if (jumps < maxExtraJumps) {
          if (player.isJumping) {
            player.addEffect('levitation', 25, { amplifier: 8, showParticles: true });
            jumps += 1
          }
        }
        if (player.isOnGround) {
          jumps = 0
        }
        player.setDynamicProperty('arena:jumps', jumps)
      }
       if (player.hasTag('arena:fox_mask_head')) {
        let jumps = player.getDynamicProperty('arena:jumps_fox') || 0
        const maxExtraJumps = 1
        if (player.isFalling && jumps < maxExtraJumps) {
          if (player.isJumping) {
            let { x, y, z } = player.getVelocity()
            player.applyKnockback(x, z, 7 * Math.sqrt(x * x + z * z), 0.65)
            jumps += 1
          }
        }
        if (player.isOnGround) {
          jumps = 0
        }
        player.setDynamicProperty('arena:jumps_fox', jumps)
      }
        });
    }, 1)
    system.runInterval(() => {
        // We obtain all the players 
        let players = world.getAllPlayers()
        players.forEach(player => { //
            if (player.hasTag('arena:demon_mask_head') && !player.hasTag('mask9_cooldown') && !player.hasTag('mask9_ready')) {
                player.triggerEvent('minecraft:mask9_timer_on')
                player.addTag('mask9_cooldown')
            }
            if (player.hasTag('arena:demon_mask_head') && player.hasTag('mask9_ready')) {
                player.runCommandAsync('function mask9')
            } 
            if (player.hasTag('arena:magnet_talisman_talisman')) {
                player.runCommandAsync('execute at @e[type=item, r=12.5] run tp @e[type=item, r=12.5] ^^^+0.5 facing @s')
            }
            if (player.hasTag('arena:cat_mask_head')) {
                player.triggerEvent('minecraft:light_level')
            }
            if (player.hasTag('arena:spectral_talisman_talisman') && !player.hasTag('arena:cat_mask_head')) {
                player.triggerEvent('minecraft:light_level')
            }
        });
    }, 5)
})

world.afterEvents.worldInitialize.subscribe(() => {
    system.runInterval(() => {
        // We obtain all the players 
        let players = world.getAllPlayers()
        players.forEach(player => {
            if (player.hasTag('arena:archaic_cursed_book_archaiccharm') && player.hasTag('mask9_ready')) {
                player.runCommandAsync('xp -1l @s')
            } 
            if (player.hasTag('arena:archaic_marble_wings_archaiccharm')) {
                player.runCommandAsync('event entity @e[r=25,type=zombie_villager] villager_converted')
            }
        });
    }, 1200)
})


world.afterEvents.entityDie.subscribe((e) => {
    const { deadEntity, damageSource } = e
    let attacker = damageSource.damagingEntity
    const typea = [
        "minecraft:drowned",
        "minecraft:husk",
        "minecraft:zombie",
        "minecraft:zombie_pigman",
        "minecraft:zombie_villager"
    ];
    const typeb = [
        "minecraft:agent",
        "minecraft:allay",
        "minecraft:bat",
        "minecraft:iron_golem",
        "minecraft:npc",
        "minecraft:player",
        "minecraft:snow_golem",
        "minecraft:tadpole",
        "minecraft:villager",
        "minecraft:wandering_trader"
    ];
    const typec = [
        "minecraft:blaze",
        "minecraft:elder_guardian",
        "minecraft:evocation_illager",
        "minecraft:guardian",
        "minecraft:enderman"
    ];
    const typed = [
        "minecraft:piglin_brute",
        "minecraft:ravager"
    ];
    if (attacker?.typeId == 'minecraft:player') {
        if (attacker.hasTag('arena:archaic_arnold_archaiccharm')) {
            if (!deadEntity.hasComponent('minecraft:is_baby') && !typea.includes(deadEntity.typeId) && !typeb.includes(deadEntity.typeId) && !typec.includes(deadEntity.typeId) && !typed.includes(deadEntity.typeId) && deadEntity.typeId != "minecraft:ender_dragon" && deadEntity.typeId != "minecraft:wither") {
                attacker.runCommand("xp 5 @s");
            } else if ((deadEntity.hasComponent('minecraft:is_baby') && typea.includes(deadEntity.typeId)) || typec.includes(deadEntity.typeId)) {
                attacker.runCommand("xp 10 @s");
            } else if (typed.includes(deadEntity.typeId)) {
                attacker.runCommand("xp 200 @s");
            } else if (deadEntity.typeId == "minecraft:wither") {
                attacker.runCommand("xp 500 @s");
            } else if (deadEntity.typeId == "minecraft:ender_dragon") {
                attacker.runCommand("xp 500 @s");
            }
        }
        if (attacker.hasTag('arena:doble_edged_charm')) {
            let kills = attacker.getDynamicProperty('doble_edged_kills')
            if (kills) {
                kills += 1
                attacker.setDynamicProperty('doble_edged_kills', kills)
            } else {
                attacker.setDynamicProperty('doble_edged_kills', 1)
            }
        }

        if (attacker.hasTag('arena:archaic_triple_edged_sword_archaiccharm')) {
            let kills = attacker.getDynamicProperty('triple_edged_kills')
            if (kills) {
                kills += 1
                attacker.setDynamicProperty('triple_edged_kills', kills)
            } else {
                attacker.setDynamicProperty('triple_edged_kills', 1)
            }
        }

        if (attacker.hasTag('arena:nefrite_edged_sword_talisman_talisman')) {
            let kills = attacker.getDynamicProperty('edged_kills')
            if (kills) {
                kills += 1
                attacker.setDynamicProperty('edged_kills', kills)
            } else {
                attacker.setDynamicProperty('edged_kills', 1)
            }
        }
        if (attacker.hasTag('arena:wither_mask_head')) {
            attacker.runCommand("playsound mob.wither.ambient @a[r=7]")
        }
        if (attacker.hasTag('arena:marble_skull_charm_charm')) {
            attacker.addEffect('levitation', 100, { amplifier: 0, showParticles: true });
            attacker.runCommand("execute as @e[family=monster,r=2] at @s run tp @s ~~-2~")
        }
        if (attacker.hasTag('arena:archaic_sacret_skull_archaiccharm')) {
            attacker.addEffect('darkness', 200, { amplifier: 0, showParticles: true });
            attacker.addTag('skull_kill')
            attacker.runCommand("particle minecraft:soul_particle ~~+0.2~")
        }
    }
})

world.afterEvents.entityHurt.subscribe(e => {
    const { hurtEntity, damageSource, damage } = e
    const chance = 1.0;
    const undead = [
        "minecraft:bogged",
        "minecraft:drowned",
        "minecraft:husk",
        "minecraft:phantom",
        "minecraft:skeleton",
        "minecraft:skeleton_horse",
        "minecraft:stray",
        "minecraft:wither_skeleton",
        "minecraft:zoglin",
        "minecraft:zombie",
        "minecraft:zombie_horse",
        "minecraft:zombie_pigman",
        "minecraft:zombie_villager"
    ];
    const guardians = [
        "minecraft:elder_guardian",
        "minecraft:guardian"
    ];
    const bosses = [ 
        "minecraft:ender_dragon",
        "minecraft:wither",
        "minecraft:warden",
        "minecraft:elder_guardian",
        "minecraft:piglin_brute",
        "minecraft:ravager"
    ];
    const health = hurtEntity.getComponent('minecraft:health').currentValue;
    let cancel_hit = false;
    let attacker = damageSource.damagingEntity
    if (attacker?.typeId == 'minecraft:player') {
        // Effects list
        // effect: is the name of the effect
        // condition: if it needs an external condition or even having another tag (for doing sets)
        // If the trinket doesnt need any conditions, write 1 or True
        // level: the level of the given effect

        // Tag = item identifier + slot
        const activeEffects = {
            'arena:natural_butterfly_mask_head': [
                { effect: 'wither', level: 4, condition: 1, effectTime: 120 }
            ],
            'arena:amethyst_earring_jelewer_ring': [
                { effect: 'slowness', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:crimsom_earring_jelewer_ring': [
                { effect: 'poison', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:crimsom_amethyst_earring_jelewer_ring': [
                { effect: 'weakness', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:iron_end_necklace_jelewer_necklace': [
                { effect: 'levitation', level: 1, condition: 1, effectTime: 3 }
            ],
            'arena:iron_fire_necklace_jelewer_necklace': [
                { effect: 'weakness', level: 2, condition: 1, effectTime: 180 }
            ],
            'arena:iron_poison_necklace_jelewer_necklace': [
                { effect: 'poison', level: 2, condition: 1, effectTime: 180 }
            ],
            'arena:iron_snow_necklace_jelewer_necklace': [
                { effect: 'slowness', level: 2, condition: 1, effectTime: 180 }
            ],
            'arena:golden_end_necklace_jelewer_necklace': [
                { effect: 'levitation', level: 2, condition: 1, effectTime: 120 }
            ],
            'arena:golden_fire_necklace_jelewer_necklace': [
                { effect: 'weakness', level: 3, condition: 1, effectTime: 240 }
            ],
            'arena:golden_poison_necklace_jelewer_necklace': [
                { effect: 'poison', level: 3, condition: 1, effectTime: 240 }
            ],
            'arena:golden_snow_necklace_jelewer_necklace': [
                { effect: 'slowness', level: 3, condition: 1, effectTime: 240 }
            ],
            'arena:prismarine_end_necklace_jelewer_necklace': [
                { effect: 'levitation', level: 3, condition: 1, effectTime: 150 }
            ],
            'arena:prismarine_fire_necklace_jelewer_necklace': [
                { effect: 'weakness', level: 4, condition: 1, effectTime: 300 }
            ],
            'arena:prismarine_poison_necklace_jelewer_necklace': [
                { effect: 'poison', level: 4, condition: 1, effectTime: 300 }
            ],
            'arena:prismarine_snow_necklace_jelewer_necklace': [
                { effect: 'slowness', level: 4, condition: 1, effectTime: 300 }
            ],
            'arena:netherite_end_necklace_jelewer_necklace': [
                { effect: 'levitation', level: 4, condition: 1, effectTime: 150 }
            ],
            'arena:netherite_fire_necklace_jelewer_necklace': [
                { effect: 'weakness', level: 5, condition: 1, effectTime: 360 }
            ],
            'arena:netherite_poison_necklace_jelewer_necklace': [
                { effect: 'poison', level: 5, condition: 1, effectTime: 360 }
            ],
            'arena:netherite_snow_necklace_jelewer_necklace': [
                { effect: 'slowness', level: 5, condition: 1, effectTime: 360 }
            ],
            'arena:archaic_chained_soul_archaiccharm': [
                { effect: 'wither', level: 1, condition: attacker.getComponent('minecraft:health').currentValue <= 6, effectTime: 120 }
            ], 
            'arena:archaic_soul_hand_archaiccharm': [
                { effect: 'wither', level: 1, condition: attacker.getComponent('minecraft:health').currentValue <= 5, effectTime: 120 },
                { effect: 'poison', level: 1, condition: attacker.getComponent('minecraft:health').currentValue <= 5, effectTime: 120 }
            ], 
        };
        // Estos hacen cosas diferentes a efectos 
        if (attacker.hasTag('arena:blaze_skull_mask_head') && damageSource.cause != 'projectile') {
            hurtEntity.setOnFire(3)
        }
        if (attacker.hasTag('arena:demon_mask_head') && attacker.hasTag('mask9_ready')) {
            hurtEntity.applyDamage(damage * 2)
            attacker.removeTag('mask9_ready')
        }
        if (attacker.hasTag('arena:iron_fire_necklace_jelewer_necklace')) {
            hurtEntity.setOnFire(3)
            if (2 >= Math.ceil(Math.random() * 100)) {
                hurtEntity.applyDamage(damage * 0.5)
            }
        }
        if (attacker.hasTag('arena:archaic_soul_hand_archaiccharm')) {
            hurtEntity.applyDamage(health*0.15)
        }
        if (attacker.hasTag('arena:iron_end_necklace_jelewer_necklace') && 4 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:iron_light_necklace_jelewer_necklace') && 8 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 1)
        }
        if (attacker.hasTag('arena:iron_snow_necklace_jelewer_necklace') && 4 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:golden_fire_necklace_jelewer_necklace')) {
            hurtEntity.setOnFire(3)
            if (4 >= Math.ceil(Math.random() * 100)) {
                hurtEntity.applyDamage(damage * 0.5)
            }
        }
        if (attacker.hasTag('arena:golden_end_necklace_jelewer_necklace') && 8 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:golden_light_necklace_jelewer_necklace') && 16 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 1)
        }
        if (attacker.hasTag('arena:golden_snow_necklace_jelewer_necklace') && 8 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:prismarine_fire_necklace_jelewer_necklace')) {
            hurtEntity.setOnFire(3)
            if (6 >= Math.ceil(Math.random() * 100)) {
                hurtEntity.applyDamage(damage * 0.5)
            }
        }
        if (attacker.hasTag('arena:prismarine_end_necklace_jelewer_necklace') && 12 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:prismarine_light_necklace_jelewer_necklace') && 24 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 1)
        }
        if (attacker.hasTag('arena:prismarine_snow_necklace_jelewer_necklace') && 16 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:netherite_fire_necklace_jelewer_necklace')) {
            hurtEntity.setOnFire(3)
            if (8 >= Math.ceil(Math.random() * 100)) {
                hurtEntity.applyDamage(damage * 0.5)
            }
        }
        if (attacker.hasTag('arena:netherite_end_necklace_jelewer_necklace') && 16 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:netherite_light_necklace_jelewer_necklace') && 32 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 1)
        }
        if (attacker.hasTag('arena:netherite_snow_necklace_jelewer_necklace') && 16 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:archaic_marble_wings_archaiccharm') && hurtEntity.matches({ families: [ "undead" ]}) && attacker.getComponent('equippable').getEquipment('Chest')?.typeId == 'minecraft:elytra') {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:archaic_marble_wings_archaiccharm') && attacker.hasTag('arena:hermes_boots_talisman_talisman') && hurtEntity.matches({ families: [ "monster" ]}) && attacker.getComponent('equippable').getEquipment('Chest')?.typeId == 'arena:marble_chestplate') {
            hurtEntity.applyDamage(damage * 0.6)
        }
         if (hurtEntity.hasTag('arena:archaic_marble_wings_archaiccharm') && hurtEntity.hasTag('arena:hermes_boots_talisman_talisman')  && attacker.matches({ families: [ "monster" ]}) && hurtEntity.getComponent('equippable').getEquipment('Chest')?.typeId == 'arena:marble_chestplate') {
            attacker.applyDamage(damage * 1)
        }
        if (attacker.hasTag('arena:archaic_incript_paper_archaiccharm') && 25 >= Math.ceil(Math.random() * 100)) {
            attacker.addEffect('absorption', 120, { amplifier: 0, showParticles: false });
        }
        if (attacker.hasTag('arena:archaic_light_cepter_archaiccharm') && 5 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 1.5)
        }
        if (attacker.hasTag('arena:archaic_light_cepter_archaiccharm') && 35 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.runCommand('execute as @s at @s run summon lightning_bolt ~ ~ ~');
        }
        if (attacker.hasTag('arena:light_necklace_necklace') && 10 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.runCommand('execute as @s at @s run summon lightning_bolt ~ ~ ~');
        } 
        if (attacker.hasTag('arena:blessed_skull_charm_charm') && 15 >= Math.ceil(Math.random() * 100)) {
            let health = attacker.getComponent('minecraft:health').currentValue
            attacker.getComponent('minecraft:health').setCurrentValue(health + damage * 0.36)
        }
        if (attacker.hasTag('skull_kill')) {
            hurtEntity.removeTag('skull_kill');
        } 
        if (attacker.hasTag('skull_kill') && 20 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 1)
        }
        if (attacker.hasTag('arena:poseidon_mask_head')) {
            if (guardians.includes(hurtEntity?.typeId)) {
                hurtEntity.applyDamage(damage * 0.8)
            }
        }
        if (attacker.hasTag('arena:archaic_good_and_evil_flower_archaiccharm')) {
            if (bosses.includes(hurtEntity?.typeId)) {
                hurtEntity.applyDamage(damage * 0.8)
            }
        }
        if (attacker.hasTag('arena:doble_edged_charm')) {
            let kills = attacker.getDynamicProperty('doble_edged_kills')
            if (kills >= 12) {
                hurtEntity.applyDamage(damage * 0.4)
                hurtEntity.setOnFire(3)
                attacker.setDynamicProperty('doble_edged_kills', 0)
            }
        }
        if (attacker.hasTag('arena:archaic_triple_edged_sword_archaiccharm')) {
            let kills = attacker.getDynamicProperty('triple_edged_kills')
            if (kills >= 60) {
                hurtEntity.applyDamage(damage * 1)
                hurtEntity.setOnFire(3)
                attacker.setDynamicProperty('triple_edged_kills', 0)
            }
        }
        if (attacker.hasTag('arena:nefrite_edged_sword_talisman_talisman')) {
            let kills = attacker.getDynamicProperty('edged_kills')
            if (kills >= 6) {
                hurtEntity.applyDamage(damage + 5)
                attacker.setDynamicProperty('edged_kills', 0)
            }
        }
        giveEffect(attacker, activeEffects, hurtEntity)
    }
    if (hurtEntity?.typeId == 'minecraft:player') {

        // Effects list
        // effect: is the name of the effect
        // condition: if it needs an external condition or even having another tag (for doing sets)
        // If the trinket doesnt need any conditions, write 1 or True
        // level: the level of the given effect

        // Tag = item identifier + slot
        const activeEffects = {
            'arena:amethyst_earring_jelewer_ring': [
                { effect: 'slowness', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:crimsom_earring_jelewer_ring': [
                { effect: 'poison', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:crimsom_amethyst_earring_jelewer_ring': [
                { effect: 'weakness', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:unnatural_mask_head': [
                { effect: 'wither', level: 4, condition: 1, effectTime: 120 }
            ]
        } 
        if (hurtEntity.hasTag('arena:blaze_skull_mask_head')) {
            attacker.setOnFire(3)
        } 
        if (hurtEntity.hasTag('arena:death_skull_talisman_talisman')) {
            attacker.applyDamage(damage * 0.25)
        }
        if (hurtEntity.hasTag('arena:thorn_pendant_necklace')) {
            attacker.applyDamage(damage * 0.25)
        }
        if (hurtEntity.hasTag('arena:archaic_blessed_shield_archaiccharm') && 15 >= Math.ceil(Math.random() * 100)) {
            attacker.applyDamage(damage * 2)
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage)
        }
        if (hurtEntity.hasTag('arena:sacronkaiden_doll_doll')) {
            attacker.applyDamage(damage + 3)
        }
        if (hurtEntity.hasTag('arena:archaic_incript_paper_archaiccharm')) {
            attacker.runCommandAsync(`xp ${Math.floor(damage * 0.25)}`)
        }
        if (hurtEntity.hasTag('arena:obsidian_eye_talisman_talisman') && 25 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.runCommandAsync('function evasion')
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage)
        }
        if (hurtEntity.hasTag('arena:ethereal_sight_mask_head')) {
            hurtEntity.runCommandAsync('function mask_tp')
        }
        if (hurtEntity.hasTag('arena:ethereal_sight_mask_head') && damageSource.cause == 'projectile') {
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage)
        }
        giveEffect(hurtEntity, activeEffects, attacker)
    }
    if (Math.random() < 0.3*chance && hurtEntity.hasTag("skull_kill") && damageSource.damagingEntity != undefined && damageSource.damagingEntity.isValid() && damageSource.damagingProjectile == undefined) {
        let health = hurtEntity.getComponent("minecraft:health");
        health.setCurrentValue(Math.min(health.currentValue + damage, health.effectiveMax));
        damageSource.damagingEntity.applyDamage(damage, { damagingEntity: hurtEntity, cause: "magic" });
        cancel_hit = true;
    }
})

function giveEffect(player, tags, entity) {
    let effects = {};
    let effectTimes = {}; // Almacenar tiempos de cada efecto

    for (const [tag, effectList] of Object.entries(tags)) {
        if (!player.hasTag(tag)) continue;

        effectList.forEach(({ effect, condition, level, effectTime }) => {
            if (condition) {
                // Suma niveles correctamente y actualiza tiempos
                effects[effect] = (effects[effect] || 0) + level; // Suma niveles directamente
                effectTimes[effect] = Math.max(effectTimes[effect] || 0, effectTime);
            }
        });
    }

    // Manejo de efectos en conflicto
    const conflictingEffects = [
        { effect1: 'poison', effect2: 'regeneration' },
        { effect1: 'weakness', effect2: 'strength' },
        { effect1: 'mining_fatigue', effect2: 'haste' },
        { effect1: 'slowness', effect2: 'speed' }
    ];

    conflictingEffects.forEach(({ effect1, effect2 }) => {
        const level1 = effects[effect1] || 0;
        const level2 = effects[effect2] || 0;

        if (level1 > 0 && level2 > 0) {
            if (level1 === level2) {
                // Si los niveles son iguales, ambos se cancelan
                delete effects[effect1];
                delete effects[effect2];
                delete effectTimes[effect1];
                delete effectTimes[effect2];
            } else {
                // Mantiene el efecto más fuerte
                const strongerEffect = level1 > level2 ? effect1 : effect2;
                const weakerEffect = level1 > level2 ? effect2 : effect1;
                effects[strongerEffect] = Math.abs(level1 - level2);
                delete effects[weakerEffect];
                delete effectTimes[weakerEffect];
            }
        }
    });

    // Aplica los efectos al jugador con los tiempos correctos
    for (const [effectName, level] of Object.entries(effects)) {
        const time = effectTimes[effectName] || 0; // Tiempo correspondiente
        entity.addEffect(effectName, time, { amplifier: level - 1, showParticles: false }); // Amplificador comienza en 0
    }
}